'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _Const = require('./Const');

var _Const2 = _interopRequireDefault(_Const);

var _events = require('events');

var Filter = (function (_EventEmitter) {
  _inherits(Filter, _EventEmitter);

  function Filter(data) {
    _classCallCheck(this, Filter);

    _EventEmitter.call(this, data);
    this.currentFilter = {};
  }

  Filter.prototype.handleFilter = function handleFilter(dataField, value, type) {
    var filterType = type || _Const2['default'].FILTER_TYPE.CUSTOM;

    if (value !== null && typeof value === 'object') {
      // value of the filter is an object
      var hasValue = true;
      for (var prop in value) {
        if (!value[prop] || value[prop] === '') {
          hasValue = false;
          break;
        }
      }
      // if one of the object properties is undefined or empty, we remove the filter
      if (hasValue) {
        this.currentFilter[dataField] = { value: value, type: filterType };
      } else {
        delete this.currentFilter[dataField];
      }
    } else if (!value || value.trim() === '') {
      delete this.currentFilter[dataField];
    } else {
      this.currentFilter[dataField] = { value: value.trim(), type: filterType };
    }
    this.emit('onFilterChange', this.currentFilter);
  };

  return Filter;
})(_events.EventEmitter);

exports.Filter = Filter;