'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactToastr = require('react-toastr');

var ToastrMessageFactory = _react2['default'].createFactory(_reactToastr.ToastMessage.animation);

var Notification = (function (_Component) {
  _inherits(Notification, _Component);

  function Notification() {
    _classCallCheck(this, Notification);

    _Component.apply(this, arguments);
  }

  // allow type is success,info,warning,error

  Notification.prototype.notice = function notice(type, msg, title) {
    this.refs.toastr[type](msg, title, {
      mode: 'single',
      timeOut: 5000,
      extendedTimeOut: 1000,
      showAnimation: 'animated  bounceIn',
      hideAnimation: 'animated bounceOut'
    });
  };

  Notification.prototype.render = function render() {
    return _react2['default'].createElement(_reactToastr.ToastContainer, { ref: 'toastr',
      toastMessageFactory: ToastrMessageFactory,
      id: 'toast-container',
      className: 'toast-top-right' });
  };

  return Notification;
})(_react.Component);

exports['default'] = Notification;
module.exports = exports['default'];