'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Const = require('./Const');

var _Const2 = _interopRequireDefault(_Const);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _SelectRowHeaderColumn = require('./SelectRowHeaderColumn');

var _SelectRowHeaderColumn2 = _interopRequireDefault(_SelectRowHeaderColumn);

var Checkbox = (function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox() {
    _classCallCheck(this, Checkbox);

    _Component.apply(this, arguments);
  }

  Checkbox.prototype.componentDidMount = function componentDidMount() {
    this.update(this.props.checked);
  };

  Checkbox.prototype.componentWillReceiveProps = function componentWillReceiveProps(props) {
    this.update(props.checked);
  };

  Checkbox.prototype.update = function update(checked) {
    _reactDom2['default'].findDOMNode(this).indeterminate = checked === 'indeterminate';
  };

  Checkbox.prototype.render = function render() {
    return _react2['default'].createElement('input', { className: 'react-bs-select-all',
      type: 'checkbox',
      checked: this.props.checked,
      onChange: this.props.onChange });
  };

  return Checkbox;
})(_react.Component);

var TableHeader = (function (_Component2) {
  _inherits(TableHeader, _Component2);

  function TableHeader() {
    _classCallCheck(this, TableHeader);

    _Component2.apply(this, arguments);
  }

  TableHeader.prototype.render = function render() {
    var containerClasses = _classnames2['default']('react-bs-container-header', 'table-header-wrapper');
    var tableClasses = _classnames2['default']('table', 'table-hover', {
      'table-bordered': this.props.bordered,
      'table-condensed': this.props.condensed
    });
    var selectRowHeaderCol = null;
    if (!this.props.hideSelectColumn) selectRowHeaderCol = this.renderSelectRowHeader();
    this._attachClearSortCaretFunc();

    return _react2['default'].createElement(
      'div',
      { ref: 'container', className: containerClasses },
      _react2['default'].createElement(
        'table',
        { className: tableClasses },
        _react2['default'].createElement(
          'thead',
          null,
          _react2['default'].createElement(
            'tr',
            { ref: 'header' },
            selectRowHeaderCol,
            this.props.children
          )
        )
      )
    );
  };

  TableHeader.prototype.renderSelectRowHeader = function renderSelectRowHeader() {
    if (this.props.rowSelectType === _Const2['default'].ROW_SELECT_SINGLE) {
      return _react2['default'].createElement(_SelectRowHeaderColumn2['default'], null);
    } else if (this.props.rowSelectType === _Const2['default'].ROW_SELECT_MULTI) {
      return _react2['default'].createElement(
        _SelectRowHeaderColumn2['default'],
        null,
        _react2['default'].createElement(Checkbox, {
          onChange: this.props.onSelectAllRow,
          checked: this.props.isSelectAll })
      );
    } else {
      return null;
    }
  };

  TableHeader.prototype._attachClearSortCaretFunc = function _attachClearSortCaretFunc() {
    var _props = this.props;
    var sortIndicator = _props.sortIndicator;
    var children = _props.children;
    var sortName = _props.sortName;
    var sortOrder = _props.sortOrder;
    var onSort = _props.onSort;

    if (Array.isArray(children)) {
      for (var i = 0; i < children.length; i++) {
        var _children$i$props = children[i].props;
        var dataField = _children$i$props.dataField;
        var dataSort = _children$i$props.dataSort;

        var sort = dataSort && dataField === sortName ? sortOrder : undefined;
        this.props.children[i] = _react2['default'].cloneElement(children[i], { key: i, onSort: onSort, sort: sort, sortIndicator: sortIndicator });
      }
    } else {
      var _children$props = children.props;
      var dataField = _children$props.dataField;
      var dataSort = _children$props.dataSort;

      var sort = dataSort && dataField === sortName ? sortOrder : undefined;
      this.props.children = _react2['default'].cloneElement(children, { key: 0, onSort: onSort, sort: sort, sortIndicator: sortIndicator });
    }
  };

  return TableHeader;
})(_react.Component);

TableHeader.propTypes = {
  rowSelectType: _react.PropTypes.string,
  onSort: _react.PropTypes.func,
  onSelectAllRow: _react.PropTypes.func,
  sortName: _react.PropTypes.string,
  sortOrder: _react.PropTypes.string,
  hideSelectColumn: _react.PropTypes.bool,
  bordered: _react.PropTypes.bool,
  condensed: _react.PropTypes.bool,
  isFiltered: _react.PropTypes.bool,
  isSelectAll: _react.PropTypes.oneOf([true, 'indeterminate', false]),
  sortIndicator: _react.PropTypes.bool
};

exports['default'] = TableHeader;
module.exports = exports['default'];