'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Const = require('../Const');

var _Const2 = _interopRequireDefault(_Const);

var RegexFilter = (function (_Component) {
  _inherits(RegexFilter, _Component);

  function RegexFilter(props) {
    _classCallCheck(this, RegexFilter);

    _Component.call(this, props);
    this.filter = this.filter.bind(this);
    this.timeout = null;
  }

  RegexFilter.prototype.filter = function filter(event) {
    var _this = this;

    if (this.timeout) {
      clearTimeout(this.timeout);
    }
    var filterValue = event.target.value;
    this.timeout = setTimeout(function () {
      _this.props.filterHandler(filterValue, _Const2['default'].FILTER_TYPE.REGEX);
    }, this.props.delay);
  };

  RegexFilter.prototype.componentDidMount = function componentDidMount() {
    var value = this.refs.inputText.defaultValue;
    if (value) {
      this.props.filterHandler(value, _Const2['default'].FILTER_TYPE.REGEX);
    }
  };

  RegexFilter.prototype.componentWillUnmount = function componentWillUnmount() {
    clearTimeout(this.timeout);
  };

  RegexFilter.prototype.render = function render() {
    var _props = this.props;
    var defaultValue = _props.defaultValue;
    var placeholder = _props.placeholder;
    var columnName = _props.columnName;

    return _react2['default'].createElement('input', { ref: 'inputText',
      className: 'filter text-filter form-control',
      type: 'text',
      onChange: this.filter,
      placeholder: placeholder || 'Enter Regex for ' + columnName + '...',
      defaultValue: defaultValue ? defaultValue : '' });
  };

  return RegexFilter;
})(_react.Component);

RegexFilter.propTypes = {
  filterHandler: _react.PropTypes.func.isRequired,
  defaultValue: _react.PropTypes.string,
  delay: _react.PropTypes.number,
  placeholder: _react.PropTypes.string,
  columnName: _react.PropTypes.string
};

RegexFilter.defaultProps = {
  delay: _Const2['default'].FILTER_DELAY
};

exports['default'] = RegexFilter;
module.exports = exports['default'];