'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Const = require('../Const');

var _Const2 = _interopRequireDefault(_Const);

var SelectFilter = (function (_Component) {
  _inherits(SelectFilter, _Component);

  function SelectFilter(props) {
    _classCallCheck(this, SelectFilter);

    _Component.call(this, props);
    this.filter = this.filter.bind(this);
    this.state = {
      isPlaceholderSelected: this.props.defaultValue === undefined || !this.props.options.hasOwnProperty(this.props.defaultValue)
    };
  }

  SelectFilter.prototype.filter = function filter(event) {
    var value = event.target.value;

    this.setState({ isPlaceholderSelected: value === '' });
    this.props.filterHandler(value, _Const2['default'].FILTER_TYPE.SELECT);
  };

  SelectFilter.prototype.getOptions = function getOptions() {
    var optionTags = [];
    var _props = this.props;
    var options = _props.options;
    var placeholder = _props.placeholder;
    var columnName = _props.columnName;

    optionTags.push(_react2['default'].createElement(
      'option',
      { key: '-1', value: '' },
      placeholder || 'Select ' + columnName + '...'
    ));
    _Object$keys(options).map(function (key) {
      optionTags.push(_react2['default'].createElement(
        'option',
        { key: key, value: key },
        options[key]
      ));
    });
    return optionTags;
  };

  SelectFilter.prototype.componentDidMount = function componentDidMount() {
    var value = this.refs.selectInput.value;
    if (value) {
      this.props.filterHandler(value, _Const2['default'].FILTER_TYPE.SELECT);
    }
  };

  SelectFilter.prototype.render = function render() {
    var selectClass = _classnames2['default']('filter', 'select-filter', 'form-control', { 'placeholder-selected': this.state.isPlaceholderSelected });

    return _react2['default'].createElement(
      'select',
      { ref: 'selectInput',
        className: selectClass,
        onChange: this.filter,
        defaultValue: this.props.defaultValue !== undefined ? this.props.defaultValue : '' },
      this.getOptions()
    );
  };

  return SelectFilter;
})(_react.Component);

SelectFilter.propTypes = {
  filterHandler: _react.PropTypes.func.isRequired,
  options: _react.PropTypes.object.isRequired,
  placeholder: _react.PropTypes.string,
  columnName: _react.PropTypes.string
};

exports['default'] = SelectFilter;
module.exports = exports['default'];