'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var PageButton = (function (_Component) {
  _inherits(PageButton, _Component);

  function PageButton(props) {
    var _this = this;

    _classCallCheck(this, PageButton);

    _Component.call(this, props);

    this.pageBtnClick = function (e) {
      e.preventDefault();
      _this.props.changePage(e.currentTarget.textContent);
    };
  }

  PageButton.prototype.render = function render() {
    var classes = _classnames2['default']({
      'active': this.props.active,
      'disabled': this.props.disable,
      'hidden': this.props.hidden
    });
    return _react2['default'].createElement(
      'li',
      { className: classes },
      _react2['default'].createElement(
        'a',
        { href: '#', onClick: this.pageBtnClick },
        this.props.children
      )
    );
  };

  return PageButton;
})(_react.Component);

PageButton.propTypes = {
  changePage: _react.PropTypes.func,
  active: _react.PropTypes.bool,
  disable: _react.PropTypes.bool,
  hidden: _react.PropTypes.bool,
  children: _react.PropTypes.node
};

exports['default'] = PageButton;
module.exports = exports['default'];